#!/bin/sh
#bilan.tcl
# \
exec wish "$0" ${1+"$@"}

#*************************************************************************
#  Copyright (C) 2002 Eric Seigne <erics@rycks.com>
# 
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  any later version.
# 
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
# 
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
# 
#**************************************************************************
#  File  : $$$
#  AUthor  : andre.connes@toulouse.iufm.fr
#  Date    : 13/08/2004 modification :
#  Licence : GNU/GPL Version 2 ou plus
# 
#  Description:
#  ------------
# 
#  @version    
#  @author     Andre Connes
#  @project    Le terrier
#  @copyright  Eric Seigne 24/04/2002
# 
#  *************************************************************************

source chemin.conf
source msg.tcl
source fonts.tcl
# les sentinelles sont en place

. configure -width 640 -height 480
wm geometry . +0+0
wm title . [mc {bilan}]
#
# initialiser la tableau des rsultats
#
set glob(liste_tcl) [glob chemin_*.tcl]
foreach programme $glob(liste_tcl) {
	set categorie [string range $programme 7 end-4]
	set table($categorie,nbfois) 0
	set table($categorie,duree_cumul) 0
	set table($categorie,duree_min) 3600
	set table($categorie,duree_max) 0
	set table($categorie,nberreurs_cumul) 0
	set table($categorie,nbcases_cumul) 0
}
#
#frame pour les boutons de choix : lve classe tous
#
frame .top -borderwidth 10
pack .top -side top -fill x
#
#crer les boutons
#
button .top.but_eleve -text [mc {eleve}] -command bilan_eleve
button .top.but_classe -state disable -text [mc {classe}] -command bilan_classe
button .top.but_tous -state disable -text [mc {tous}] -command bilan_tous 
pack .top.but_eleve .top.but_classe .top.but_tous -side left

set bg #ffff80

frame .t
text .t.text -yscrollcommand {.t.scroll set} -setgrid true \
	-width 80 -height 40 -wrap word -background $bg
scrollbar .t.scroll -command {.t.text yview}
pack .t.scroll -side right -fill y
pack .t.text -side left -fill both -expand true
pack .t -side top -fill both -expand true

frame .b
pack .b -side bottom -fill x

############################################################
proc bilan_eleve {} {
  global glob table

  cd $glob(trace_dir)
  set types {
	{"Catgories"		{.log}	}
  }
  catch {set file [tk_getOpenFile -filetypes $types]}
  if {[catch { set f [open [file join $file] "r" ] }] } {
	exit
  }
  #
  # on rcupre le nom de l'lve
  #
  set xnom [lindex [split $file "/"] end]
  set ppoint [string last "." $xnom]
  set nom [string range $xnom 0 [expr $ppoint-1]]
  #
  # lire et traiter les rsulats de l'lve 
  #
  set f [open [file join $file] "r" ] 
  while {![eof $f]} {
    set ligne [gets $f]
    if {[llength $ligne ] > 0 } {
      #
      # afficher les traces brutes ligne  ligne
      #
#      .t.text insert end $ligne\n
#      .t.text see end
      #
      # dcomposition des traces
      #
      set titre [lindex $ligne 0]
      set categorie [lindex $ligne 1]
      incr table($categorie,nbfois)
      set quoi [lindex $ligne 2]
      set d [lindex [split [lindex $quoi 2] "="] 1]
      if { $d < $table($categorie,duree_min)} {
	set table($categorie,duree_min) $d
      }
      if { $d > $table($categorie,duree_max)} {
        set table($categorie,duree_max) $d
      }
      incr table($categorie,duree_cumul) $d
      set ec [split [lindex [split [lindex $quoi 3] "="] 1] "/" ]
      set e [lindex $ec 0]
      incr table($categorie,nberreurs_cumul) $e
      set c [lindex $ec 1]
      incr table($categorie,nbcases_cumul) $c
    }
  }
#  .t.text insert end "\n"
#  .t.text see end
  #
  # synthtiser
  #
  set fnom $nom.bilan
  set f [open $fnom w]
  puts $f "[mc {synthese}] : $nom"
  puts $f "+----------------------+-------+-----------------------+-------+"
  puts $f [format "| %-20s | %5s | %5s   %5s   %5s | %5s |" \
	"la" \
	"nbre" \
	" " \
	"dure" \
	" " \
	"nberr" ]
  puts $f [format "| %-20s | %5s | %5s | %5s | %5s | %5s |" \
	"catgorie" \
	"fois" \
	"min" \
	"moy" \
	"max" \
	"100 c" ]
  puts $f "+----------------------+-------+-------+-------+-------+-------+"
  foreach programme $glob(liste_tcl) {
    set categorie [string range $programme 7 end-4]
    if { $table($categorie,nbfois)>0 } {
        puts $f [format "| %-20s | %5s | %5s | %5s | %5s | %5s |" \
	  $categorie \
	  $table($categorie,nbfois) \
	  $table($categorie,duree_min) \
	  [expr int($table($categorie,duree_cumul)/$table($categorie,nbfois))]  \
	  $table($categorie,duree_max) \
	  [expr 100*$table($categorie,nberreurs_cumul)/$table($categorie,nbcases_cumul)]]
    }
  }
  puts $f "+----------------------+-------+-------+-------+-------+-------+"
  close $f
  #
  #le fichier est sauvegard dans $glob(trace_dir)/nom_eleve.bilan
  # maintenant on l'affiche
  #
  set f [open $fnom r]
  while { ! [eof $f] } {
    set line [gets $f]
    .t.text insert end $line\n
    .t.text see end
  }
  close $f

  .t.text insert end "\n[mc {trace_en}] $file"
  .t.text see end
  .t.text insert end "\n[mc {synthese_en}] $fnom"
  .t.text see end

  .t.text insert end "\n[mc {effacer_fichiers}] ?"
  .t.text insert end { OUI } tagoui { NON } tagnon
  set bold "-background #43ce80 -relief raised -borderwidth 5"
  set normal "-background #ffff80 -relief flat"
  foreach tag { tagoui tagnon } {
    .t.text tag bind $tag <Any-Enter> ".t.text tag configure $tag $bold"
    .t.text tag bind $tag <Any-Leave> ".t.text tag configure $tag $normal"
  }
  .t.text tag bind tagoui <1> "file delete $fnom; file delete $file; exit"
  .t.text tag bind tagnon <1> "exit"


} ;# fin bilan_eleve

###################################################################################

proc bilan_classe {} {
  .t.text insert end "\n\nBilan classe : [mc {non_implante}].\n\n"
}

proc bilan_tous {} {
  .t.text insert end "\n\nBilan tous les lves : [mc {non_implante}].\n\n"
}
